<?php
//if this file is called directly, abort.
if(!defined('ABSPATH')) die('please, do not call this page directly');

//define option page parameters
if(!function_exists('mnnt_check_register')){
	
	function mnnt_check_register() {	
			
		if(!empty($_POST['mnnt-register-button'])) {
						
			global $mnnt_register_error;
			$mnnt_register_error = false;
			
			global $mnnt_register_info;
			$mnnt_register_info = false;
			
			//get and verify nonce
			$mnnt_register_nonce = $_POST['mnnt-register-button'];
			
			if(!wp_verify_nonce($mnnt_register_nonce, 'mnnt-register-nonce')) {
				
				$mnnt_register_error = __('An error occurred','mnntlang').', '.__('please retry','mnntlang');
				return;
				
			}
			
			$mnnt_register_email_posted = null;
			$mnnt_register_password_posted = null;
			$mnnt_register_dafult_acceptance_posted = null;
			$mnnt_register_secondary_acceptance_posted = null;
			
			if(!empty($_POST['mnnt-register-email'])) {
				
				$mnnt_register_email_posted = sanitize_email(strtolower($_POST['mnnt-register-email']));
				
			}
			
			if(!empty($_POST['mnnt-register-password'])) {
				
				$mnnt_register_password_posted = trim($_POST['mnnt-register-password']);
				
			}
			
			if(!empty($_POST['mnnt-default-acceptance'])) {
				
				$mnnt_register_dafult_acceptance_posted = absint($_POST['mnnt-default-acceptance']);
				
			}

			if(!empty($_POST['mnnt-secondary-acceptance'])) {
				
				$mnnt_register_secondary_acceptance_posted = absint($_POST['mnnt-secondary-acceptance']);
				
			}			
			
			if(is_null($mnnt_register_email_posted) || is_null($mnnt_register_password_posted)) {
			
				$mnnt_register_error = __('All fields are required','mnntlang');
				return;
				
			}		
							
			//check email address
			if(/*$mnnt_register_email_posted != null && */!is_email($mnnt_register_email_posted)) {
				
				$mnnt_register_error = __('Please enter a valid email address','mnntlang');
				return;
				
			}	
									
			//check password	
			if(strlen($mnnt_register_password_posted) < 5) {
				
				$mnnt_register_error = __('Please enter a password of at least six characters','mnntlang');
				return;
				
			}
							
			if(!preg_match('/[A-Za-z]/', $mnnt_register_password_posted) || !preg_match('/[0-9]/', $mnnt_register_password_posted)) {
				
				$mnnt_register_error = __('Please enter a password with both letters and numbers','mnntlang');
				return;	
				
			}
			
			//check acceptance
			if(is_null($mnnt_register_dafult_acceptance_posted) || $mnnt_register_dafult_acceptance_posted !== 1) {
			
				$mnnt_register_error = __('Please, consent to the processing of your data for the described purposes','mnntlang');
				return;
				
			}	

			//check email exists
			if(/*$mnnt_register_email_posted != null && */email_exists($mnnt_register_email_posted)) {
				
				$mnnt_register_error = __('An account with this email is already registered','mnntlang').': <a href="?mnnt-action=login" title="'.__('Log In','mnntlang').'" alt="'.__('Log In','mnntlang').'">'.__('Log In','mnntlang').'</a> '.__('or','mnntlang').' <a href="?mnnt-action=lostpassword" title="'.__('Get a new password','mnntlang').'" alt="'.__('Get a new password','mnntlang').'">'.__('Get a new password','mnntlang').'</a>';
				return;
				
			}			
						
			$mnnt_register_new_user_arguments = array(
			
				'user_login'	=>	$mnnt_register_email_posted,
				'user_email'	=>	$mnnt_register_email_posted,
				'user_pass'		=>	$mnnt_register_password_posted,
				'role'			=>  'main-entrance-user'

				);
		 
			$mnnt_register_new_user = wp_insert_user($mnnt_register_new_user_arguments);

			if(!is_wp_error($mnnt_register_new_user)){
				
				global $mnnt_options_array;
				$mnnt_default_acceptance_doc_id = $mnnt_options_array['default_acceptance_doc_id'];
				
				update_user_meta($mnnt_register_new_user, '_mnnt_default_acceptance_doc_id', $mnnt_default_acceptance_doc_id);
				
				if(!is_null($mnnt_register_secondary_acceptance_posted) && $mnnt_register_secondary_acceptance_posted === 1) {
					
					if(!empty($mnnt_options_array['secondary_acceptance_doc_id'])) {
						
						$mnnt_secondary_acceptance_doc_id = $mnnt_options_array['secondary_acceptance_doc_id'];
						update_user_meta($mnnt_register_new_user, '_mnnt_secondary_acceptance_doc_id', $mnnt_secondary_acceptance_doc_id);
						
					}				

				}
				
				$mnnt_register_involved_user = get_user_by('email',$mnnt_register_email_posted);
				$mnnt_register_involved_user_name_with_space = ' '.esc_html($mnnt_register_involved_user->display_name);
				
				$mnnt_login_url = get_permalink().'?mnnt-action=login';
							
				$mnnt_register_email_subject = __('Registration confirmed for','mnntlang').' '.get_bloginfo('name');
				$mnnt_register_email_body = '
					<html>
						<body>
							<p>
								'.__('Hello','mnntlang').$mnnt_register_involved_user_name_with_space.',
							</p>
							<p>
								'.__('Welcome to','mnntlang').' '.get_bloginfo('name').'!</a>
							</p>
							<p>
								'.__('Now you can','mnntlang').' <a href="'.$mnnt_login_url.'" title="'.__('Log In','mnntlang').'" alt="'.__('Log In','mnntlang').'">'.__('Log In','mnntlang').'</a>
							</p>
							<p>
								<small><em>'.__('You consented to the processing of your data for the purposes described into attached disclaimer','mnntlang').'</em></small>
							</p>
						</body>
					</html>';
				$mnnt_register_email_headers = array('Content-Type: text/html; charset=UTF-8', 'Bcc: '.get_option('admin_email')); 
				
				if(!empty($mnnt_secondary_acceptance_doc_id)) {
					
					$mnnt_register_email_attachemnts = array(
						get_attached_file($mnnt_default_acceptance_doc_id),
						get_attached_file($mnnt_secondary_acceptance_doc_id)
					);
				
				} else {
					
					$mnnt_register_email_attachemnts = array(
						get_attached_file($mnnt_default_acceptance_doc_id)
					);					
					
				}
				wp_mail($mnnt_register_email_posted, $mnnt_register_email_subject, $mnnt_register_email_body, $mnnt_register_email_headers,$mnnt_register_email_attachemnts);				
				
				$mnnt_register_info = __('Registration completed successfully','mnntlang');
				
				$mnnt_page_id_to_redirect = $mnnt_options_array['redirect_after_registration'];
				
				if(!empty($mnnt_options_array['auto_login']) && $mnnt_options_array['auto_login'] === '1') {
				
					$mnnt_posted_data = array();
					$mnnt_posted_data['user_login'] = $mnnt_register_email_posted;
					$mnnt_posted_data['user_password'] = $mnnt_register_password_posted;
					$mnnt_posted_data['remember'] = true;		
					
					$mnnt_signon = wp_signon($mnnt_posted_data);					
					
					if(is_wp_error($mnnt_signon)){
						
						$mnnt_register_error = __('Auto log in failed, please try to log in manually','mnntlang');
									
					} else {
						
						if(!empty($mnnt_page_id_to_redirect) && is_numeric($mnnt_page_id_to_redirect) && $mnnt_page_id_to_redirect !== '0') {
						
							wp_safe_redirect(get_permalink($mnnt_page_id_to_redirect));
							exit;
							
						} else {
							
							setcookie('mnnt-generic-success', '1', current_time( 'timestamp', 1 ) + 10);
							wp_safe_redirect(get_site_url());
							exit;
							
						}
						
						exit;
						
					}	

				} else  {
					
					if(!empty($mnnt_page_id_to_redirect) && is_numeric($mnnt_page_id_to_redirect) && $mnnt_page_id_to_redirect !== '0') {
					
						wp_safe_redirect(get_permalink($mnnt_page_id_to_redirect));
						exit;
						
					} else {
						
						wp_safe_redirect(get_site_url());
						exit;
						
					}
					
				}					
				
			} else {
				
				$mnnt_register_error = __('Something went wrong, please try again later','mnntlang');
				
			}
		
	
		}
			
	}
	
	add_action('template_redirect','mnnt_check_register');

	
} else {
	
	error_log('function: "mnnt_check_register" already exists');
	
}