<?php
//if this file is called directly, abort.
if(!defined('ABSPATH')) die('please, do not call this page directly');

//define option page parameters
if(!function_exists('mnnt_register_form')){
	
	function mnnt_register_form($mnnt_form_to_diplay) {

		global $mnnt_options_array;
		$mnnt_content_to_return = null;
		$mnnt_default_acceptance_doc_name =	null;
		$mnnt_default_acceptance_doc_url = null;	
		
		if(!empty($mnnt_options_array['default_acceptance_doc_id'])) {
			
			$mnnt_default_acceptance_doc_name = get_the_title($mnnt_options_array['default_acceptance_doc_id']);
			$mnnt_default_acceptance_doc_url = wp_get_attachment_url($mnnt_options_array['default_acceptance_doc_id']);
			
		}
		
		//if registration if not allowed, return a null content (even if registration page is not reachable because of a redirection set in mnnt_dependencies file)
		if(empty($mnnt_options_array['allow_registration']) || $mnnt_options_array['allow_registration'] !== '1') { 
		
			return $mnnt_content_to_return;
			
		}	
		
		if(is_user_logged_in()) {
			
			$mnnt_current_user_object = wp_get_current_user();
			$mnnt_current_name_with_space = ' '.esc_html($mnnt_current_user_object->display_name);
			
			$mnnt_content_to_return .= '
			
			<div id="mnnt-main-container" class="mnnt-main-container">
				
					<h2 id="mnnt-form-title" class="mnnt-form-title">'.__('Log Out','mnntlang').'</h2>
		
					<p>

						'.__('Hello','mnntlang').$mnnt_current_name_with_space.',<br>'.__('you are currently logged in','mnntlang').'!
						
					</p>
					
					<p>

						'.__('logout','mnntlang').'.
						
					</p>
					
					<p>
					
						<a href="'.wp_logout_url(site_url()).'" title="'.__('Log Out','mnntlang').'" alt="'.__('Log Out','mnntlang').'" class="mnnt-logout-link">'.__('Log Out','mnntlang').'</a>
						
					</p>	
			
			</div>
			
			';
					
			return $mnnt_content_to_return;			
			
		}
	
	
		$mnnt_content_to_return .= '
		
		<div id="mnnt-main-container" class="mnnt-main-container">
		
		';
				
		if(!empty($mnnt_options_array['allow_registration']) && $mnnt_options_array['allow_registration'] === '1') { 
					
			$mnnt_content_to_return .= '
			
			<div id="mnnt-menu-container" class="mnnt-menu-container">
			
				<div id="mnnt-menu" class="mnnt-menu">
				
				';
				
				if(empty($mnnt_form_to_diplay) || $mnnt_form_to_diplay === 'login') {
					
					$mnnt_content_to_return .= 
										
					__('Log In','mnntlang').' | <a href="?mnnt-action=register">'.__('Register','mnntlang').'</a></p>
					
					';
				}
				
				elseif($mnnt_form_to_diplay === 'register') {
					
					$mnnt_content_to_return .= '
	
					<a href="?mnnt-action=login">'.__('Log In','mnntlang').'</a> | '.__('Register','mnntlang')
					
					;	
					
				} else {
					
					$mnnt_content_to_return .= '
					
					<a href="?mnnt-action=login">'.__('Log In','mnntlang').'</a> | <a href="?mnnt-action=register">'.__('Register','mnntlang').'</a>
					
					';					
					
				}
				
				
				$mnnt_content_to_return .= '
				
				</div>
			
			</div>
			
			';
			
		}
		
			$mnnt_content_to_return .= '
		
			<div id="mnnt-form-container" class="mnnt-form-container">
			
				<h2 id="mnnt-form-title" class="mnnt-form-title">'.__('Register','mnntlang').'</h2>
				
				<div id="mnnt-error-container" class="mnnt-error-container">

				';
				
				global $mnnt_register_error;
				global $mnnt_register_info;
				
				if(!empty($mnnt_register_error)) {
					
					$mnnt_content_to_return .= '
						
					<div id="mnnt-error" class="mnnt-error">
					
					<p>
					
					';				
						
						
					$mnnt_content_to_return .= $mnnt_register_error;
						
					$mnnt_content_to_return .= '
		
					</p>
					
					</div>
					
					';				
						
				}
				
				$mnnt_content_to_return .= '

				</div>

				<div id="mnnt-info-container" class="mnnt-info-container">
				
				';

				
				if(!empty($mnnt_register_info)) {
					
					$mnnt_content_to_return .= '
						
					<div id="mnnt-info" class="mnnt-info">
					
					<p>
					
					';				
						
						
					$mnnt_content_to_return .= $mnnt_register_info;
						
					$mnnt_content_to_return .= '
		
					</p>
					
					</div>
					
					';				
						
				}
				
				if(!empty($_POST['mnnt-register-email'])) {
					
					$mnnt_posted_register_email = sanitize_email(strtolower($_POST['mnnt-register-email']));
					
				} else {
					
					$mnnt_posted_register_email = null;
					
				}
				
				$mnnt_content_to_return .= '
										
				</div>					

				<form method="post" action="">
										
					<p>
						<label for="mnnt-register-email">'.__('Email').'</label>
						<input type="email" name="mnnt-register-email" id="mnnt-register-email" class="mnnt-input mnnt-register-email" value="'.$mnnt_posted_register_email.'" autocorrect="off" autocapitalize="none">
						
					</p>
					
					<p>
						<label for="mnnt-register-password">'.__('Password').'</label>
						<input type="password" name="mnnt-register-password" id="mnnt-register-password" class="mnnt-input mnnt-register-password">
						
					</p>
					
					<p class="mnnt-acceptance">
						<input type="checkbox" name="mnnt-default-acceptance" id="mnnt-default-acceptance" class="mnnt-default-acceptance" value="1">
						<label for="mnnt-default-acceptance-text">'.$mnnt_options_array['default_acceptance_text'].'
						<a href="'.$mnnt_default_acceptance_doc_url.'" title="'.__('GDPR and privacy information','mnntlang').'" alt="'.__('GDPR and privacy information','mnntlang').'" target="_blank">'.$mnnt_default_acceptance_doc_name.'</a>
						</label>
					
					
					';
					
					if(
						!empty($mnnt_options_array['secondary_acceptance']) && 
						$mnnt_options_array['secondary_acceptance'] === '1' &&
						!empty($mnnt_options_array['secondary_acceptance_text']) &&
						!empty($mnnt_options_array['secondary_acceptance_doc_id']) && 
						$mnnt_options_array['secondary_acceptance_doc_id'] !== '0' && 
						get_post_status($mnnt_options_array['secondary_acceptance_doc_id']) === 'publish'
					) {
						
						$mnnt_secondary_acceptance_doc_name = get_the_title($mnnt_options_array['secondary_acceptance_doc_id']);
						$mnnt_secondary_acceptance_doc_url = wp_get_attachment_url($mnnt_options_array['secondary_acceptance_doc_id']);
						
						$mnnt_content_to_return .= '


							<br>
							<input type="checkbox" name="mnnt-secondary-acceptance" id="mnnt-secondary-acceptance" class="mnnt-input mnnt-secondary-acceptance" value="1">
							<label for="mnnt-secondary-acceptance-text">'.$mnnt_options_array['secondary_acceptance_text'].'
							<a href="'.$mnnt_secondary_acceptance_doc_url.'" title="'.__('GDPR and privacy information','mnntlang').'" alt="'.__('GDPR and privacy information','mnntlang').'" target="_blank">'.$mnnt_secondary_acceptance_doc_name.'</a>
							</label>
						
						';
						
					}
					
					$mnnt_content_to_return .= '
					
					</p>
					<p>
						<button name="mnnt-register-button" id="mnnt-register-buton" class="button primary-button mnnt-button mnnt-register-button" value="'.wp_create_nonce('mnnt-register-nonce').'">'.__('Register','mnntlang').'</button>
					</p>
					
					
				</form>
				
			</div>
					
		
		</div>
		
		';
				
		return $mnnt_content_to_return;
	
	}
	
} else {
	
	error_log('function: "mnnt_register_form" already exists');
	
}